/*
 * FireSql a detection and protection sql injection engine.
 *
 * Copyright (C) 2012  Luis Campo Giralte
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 * Written by Luis Campo Giralte <luis.camp0.2009@gmail.com> 2012
 *
 */

#ifndef FIRESQL_ACTION_H
#define FIRESQL_ACTION_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <boost/shared_ptr.hpp>

enum class ActionCodes : short {
	CONTINUE = 0,
	DROP,
	REJECT,
	CLOSE
};

class Action 
{
public:

	virtual void PreAction(const std::string& query, ActionCodes *code) = 0;
	virtual void PostAction(ActionCodes *code) = 0;
	virtual int GetMatches() = 0;
};

typedef boost::shared_ptr<Action> ActionPtr;
 
#endif // FIRESQL_ACTION_H

